<script lang="ts" setup>
import { nextTick, onMounted, ref, watchEffect } from 'vue'
import type { VForm } from 'vuetify/components'
import type { User } from '@/types/User'
import { useUserStore } from '@/stores/user'
const userStore = useUserStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const loading = ref(false)
const user = ref<User | any>(userStore.currentUser)
const passwordDialog = ref(false)

function onSubmit() {}

async function changePassword() {
  await userStore.changePassword()
  passwordDialog.value = false
}

function formatDate(dateString: any) {
  const date = new Date(dateString)
  return date.toLocaleDateString('th-TH', {
    day: '2-digit',
    month: 'long',
    year: 'numeric'
  })
}

function closeDialog() {
  dialog.value = false
  passwordDialog.value = false
}

async function editUser() {
  if (!user.value.id) return
  await userStore.getUser(user.value.id)
  console.log('editeedUser:', userStore.editedUser)
  dialog.value = true
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await userStore.saveUser()
  await userStore.getUser(user.value.id)
  user.value = userStore.editedUser
  closeDialog()
}

const imageURL = ref<any>(null)

watchEffect(() => {
  if (userStore.editedUser.files && userStore.editedUser.files.length > 0) {
    const reader = new FileReader()
    reader.onload = (event) => {
      imageURL.value = event.target?.result
    }
    reader.readAsDataURL(userStore.editedUser.files[0])
  } else {
    imageURL.value = null
  }
})
</script>

<template>
  <v-sheet variant="outlined">
    <div style="margin-top: 10px; text-align: right; margin-right: 10px; margin-bottom: 10px">
      <v-btn>
        <v-icon @Click="editUser"> mdi-pencil </v-icon>
      </v-btn>
      <v-btn>
        <v-icon @click="passwordDialog = true"> mdi-key </v-icon>
      </v-btn>
    </div>
    <v-dialog v-model="passwordDialog" max-width="500px">
      <v-card>
        <v-card-title class="text-h5">เปลี่ยนรหัสผ่าน</v-card-title>
        <v-card-text>
          <v-row style="padding-top: 10px; padding-bottom: 20px">
            <strong>email : </strong>
            {{ userStore.editedUser.email }}
          </v-row>
          <v-form>
            <v-text-field
              v-model="userStore.editedUser.password"
              :readonly="loading"
              :rules="[(v) => !!v || 'Field is required']"
              label="รหัสผ่าน เข้าระบบ"
              placeholder="Enter password"
              clearable
              variant="outlined"
            ></v-text-field>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Cancel</v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="changePassword">save</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-card variant="outlined">
      <div class="info">
        <div>
          <v-card-title style="background-color: gray"> ประวัติส่วนต้ว </v-card-title>
        </div>

        <v-card-text>
          <v-row>
            <v-col cols="12" md="8" no-gutters>
              <v-row>
                <v-col cols="12">
                  <strong>ชื่อ - นามสกุล : </strong>
                  {{ user.name }}
                </v-col>
                <v-col cols="12" md="6">
                  <strong>วัน/เดือน/ปีเกิด : </strong>
                  {{ formatDate(user.birthDate) }}
                </v-col>
                <v-col cols="12" md="6">
                  <strong>อายุ : </strong>
                  {{ user.age }}
                </v-col>
                <v-col cols="12" md="6">
                  <strong> เพศ : </strong>
                  {{ user.gender }}
                </v-col>
                <v-col cols="12" md="6">
                  <strong> หมู่เลือด : </strong>
                  {{ user.bloodType }}
                </v-col>
                <v-col cols="12" md="6">
                  <strong> ส่วนสูง : </strong>
                  {{ user.height }}
                  <strong> ซม. </strong>
                </v-col>
                <v-col cols="12" md="6">
                  <strong> น้ําหนัก : </strong>
                  {{ user.weight }}
                  <strong> กก. </strong>
                </v-col>
              </v-row>
            </v-col>
            <v-col cols="12" md="4">
              <v-row>
                <v-img
                  :src="'http://localhost:3000/images/users/' + user.image"
                  width="200"
                  height="200"
                >
                </v-img>
              </v-row>
            </v-col>
          </v-row>

          <v-col cols="12">
            <strong> ที่อยู่ : </strong>
            {{ user.address }}
          </v-col>
        </v-card-text>
      </div>
    </v-card>
    <v-card variant="outlined" style="margin-top: 10px">
      <div>
        <v-card-title> ช่องทางการติดต่อ </v-card-title>
      </div>

      <v-card-text>
        <div class="info">
          <v-row>
            <v-col cols="12" md="6">
              <strong> เบอร์โทรศัพท์ : </strong>
              {{ user.phone }}
            </v-col>
            <v-col cols="12" md="6">
              <strong> อีเมล : </strong>
              {{ user.email }}
            </v-col>
          </v-row>
        </div>
      </v-card-text>
    </v-card>
    <v-card variant="outlined" style="margin-top: 10px">
      <div>
        <v-card-title collor="blue"> การงาน </v-card-title>
      </div>
      <v-card-text>
        <div class="info">
          <v-row>
            <v-col cols="12">
              <strong> สาขา : </strong>
              {{ user.branch?.name }}
            </v-col>
            <v-col cols="12" md="6">
              <strong> ตำแหน่ง : </strong>
              {{ user.role?.name }}
            </v-col>
            <v-col cols="12" md="6">
              <strong> เงินเดือน : </strong>
              {{ user.salary }}
            </v-col>
            <v-col cols="12" md="6">
              <strong> วันที่เริ่มงาน : </strong>
              {{ formatDate(user.startDate) }}
            </v-col>
            <v-col cols="12" md="6">
              <strong> สถานะ : </strong>
              {{ user.status }}
            </v-col>
          </v-row>
        </div>
      </v-card-text>
    </v-card>

    <div>
      <v-dialog v-model="dialog" persistent width="1024">
        <v-card>
          <v-card-title>
            <span class="text-h5">ข้อมูลพนักงาน</span>
          </v-card-title>
          <v-card-text>
            <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
              <v-container>
                <v-card title="ประวัติ" variant="outlined">
                  <div
                    style="
                      padding-left: 30px;
                      padding-right: 30px;
                      padding-top: 10px;
                      padding-bottom: 10px;
                    "
                  >
                    <v-row>
                      <v-col cols="12" md="8">
                        <v-row>
                          <v-col cols="12">
                            <v-text-field
                              v-model="userStore.editedUser.name"
                              :readonly="loading"
                              variant="outlined"
                              label="ชื่อ-นามสกุล"
                              :rules="[(v) => !!v || 'Field is required']"
                              class="mb-2"
                              clearable
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.birthDate"
                              :readonly="loading"
                              variant="outlined"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="วันเดือนปีเกิด"
                              type="Date"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.age"
                              :readonly="loading"
                              variant="outlined"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="อายุ"
                              placeholder="Enter your age"
                              type="number"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-combobox
                              v-model="userStore.editedUser.gender"
                              clearable
                              label="เพศ"
                              :items="['ชาย', 'หญิง', 'อื่นๆ']"
                              variant="outlined"
                            ></v-combobox>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-combobox
                              v-model="userStore.editedUser.bloodType"
                              clearable
                              label="หมู่เลือด"
                              variant="outlined"
                              :items="['A+', 'A-', 'B+', 'B-', 'AB+', 'AB-', 'O+', 'O-']"
                            ></v-combobox>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.height"
                              :readonly="loading"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="Height (cm.)"
                              placeholder="Enter your Height"
                              type="number"
                              variant="outlined"
                            ></v-text-field>
                          </v-col>
                          <v-col cols="12" md="6">
                            <v-text-field
                              v-model="userStore.editedUser.weight"
                              :readonly="loading"
                              :rules="[(v) => !!v || 'Field is required']"
                              clearable
                              label="Weight (kg.)"
                              placeholder="Enter your Weight"
                              type="number"
                              variant="outlined"
                            ></v-text-field>
                          </v-col>
                        </v-row>
                      </v-col>
                      <v-col cols="12" md="4">
                        <v-row>
                          <v-img
                            v-if="
                              userStore.editedUser.files && userStore.editedUser.files.length > 0
                            "
                            :src="imageURL"
                            alt="Uploaded Image"
                            width="200"
                            height="200"
                          ></v-img>
                          <v-img
                            v-else
                            :src="
                              'http://localhost:3000/images/users/' + userStore.editedUser.image
                            "
                            width="200"
                            height="200"
                          >
                          </v-img>
                        </v-row>
                        <v-row>
                          <v-file-input
                            v-model="userStore.editedUser.files"
                            :rules="[
                              (value) => {
                                return (
                                  !value ||
                                  !value.length ||
                                  value[0].size < 2000000 ||
                                  'Avatar size should be less than 2 MB!'
                                )
                              }
                            ]"
                            accept="image/png, image/jpeg"
                            placeholder="Pick an avatar"
                            prepend-icon="mdi-image"
                            label="Avatar"
                            variant="outlined"
                          ></v-file-input>
                        </v-row>
                      </v-col>
                      <v-row>
                        <v-col cols="12">
                          <v-textarea
                            v-model="userStore.editedUser.address"
                            :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']"
                            clearable
                            label="ที่อยู่"
                            variant="outlined"
                            placeholder="Enter Address"
                          ></v-textarea>
                        </v-col>
                      </v-row>
                    </v-row>
                  </div>
                </v-card>
                <v-card title="ช่องทางการติดต่อ" variant="outlined" style="margin-top: 20px">
                  <div
                    style="
                      padding-left: 30px;
                      padding-right: 30px;
                      padding-top: 10px;
                      padding-bottom: 10px;
                    "
                  >
                    <v-row>
                      <v-col cols="12" md="6">
                        <v-text-field
                          v-model="userStore.editedUser.phone"
                          :readonly="loading"
                          variant="outlined"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="เบอร์โทรศัพท์"
                          placeholder="xxx-xxx-xxxxx"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" md="6">
                        <v-text-field
                          v-model="userStore.editedUser.email"
                          :readonly="loading"
                          variant="outlined"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="อีเมล"
                          placeholder="Enter Email"
                          :type="'email'"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </div>
                </v-card>
              </v-container>
            </v-form>
            <small>*indicates required field</small>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
            <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </div>
  </v-sheet>
</template>

<style scoped>
.info {
  padding-left: 30px;
  padding-right: 30px;
  padding-top: 10px;
  padding-bottom: 10px;
}
</style>
